<?php
	if (!isset($argv[1], $argv[2])) {
		die("Usage: {$argv[0]} #instance mst_file");
	}
	
	$numero = (int)$argv[1];
	$archivo = $argv[2];
	$consumo = json_decode(@file_get_contents("power_data_{$numero}.json.txt"), true);
	$respuesta = @file($archivo, FILE_IGNORE_NEW_LINES|FILE_SKIP_EMPTY_LINES);

	if (!isset($respuesta, $consumo) || empty($respuesta)) {
		die("{$argv[0]} {$argv[1]} {$argv[2]}: unable to read the input files");
	}
	
	// MST cleaning, JSON file generation
	
	$res = new stdClass( );
	$res->Legs = new stdClass( );
	$corridas = [ ];
	$mst = [ ];
	
	foreach ($respuesta as $fila) {
		$capturas = [ ];
		
		if (preg_match('/salida_(\d+) ([-+]?\d+(\.\d+([eE][-+]?\d+)?)?)/', $fila, $capturas)) {
			$id_corrida = $capturas[1];
			$salida_corrida = (int)round($capturas[2]);
			
			$res->Legs->{$id_corrida} = $salida_corrida;
			$corridas[$id_corrida]['DepartureTime'] = $salida_corrida;
			$mst[] = "salida_{$id_corrida} {$salida_corrida}";
		}
	}
	
	file_put_contents($archivo, implode("\n", $mst));
	file_put_contents(preg_replace('/\.mst$/i', '', $archivo).'.json.txt', json_encode($res, JSON_PRETTY_PRINT));
	
	// objective function computation
	
	foreach ($consumo['Powerprofiles'] as $onda) {
		$corridas[$onda['LegID']]['Powerprofiles'] = $onda['Powerprofile'];
	}
	
	$segundos = array_fill(0, 17 * 15 * 60 + 1, 0);
	
	foreach ($corridas as $corrida) {
		$inicial = 60 * $corrida['DepartureTime'];
		
		foreach ($corrida['Powerprofiles'] as $segundo => $consumo) {
			$segundos[$inicial + $segundo] += $consumo;
		}
	}
	
	$intervalos = [ ];
	
	foreach (range(0, 16) as $bloque) {
		$segundo_ini = 15 * 60 * $bloque;
		$segundo_fin = 15 * 60 * ($bloque + 1);
		$sumando = 0;
		
		for ($i = $segundo_ini; $i <= $segundo_fin; ++$i) {
			$sumando += max($segundos[$i], 0) / (1 + (int)($i % 900 == 0));
		}

		$intervalos[] = $sumando;
	}

	echo "objective function value: ", max($intervalos) / 900, "\n";
?>